## chromium-browser 68.0.3440.75

=== tools/clang/blink_gc_plugin/CMakeLists.txt ===
set(LIBRARYNAME BlinkGCPlugin)

set(plugin_sources
  BadPatternFinder.cpp
  BlinkGCPlugin.cpp
  BlinkGCPluginConsumer.cpp
  CheckDispatchVisitor.cpp
  CheckFieldsVisitor.cpp
  CheckFinalizerVisitor.cpp
  CheckGCRootsVisitor.cpp
  CheckTraceVisitor.cpp
  CheckTraceWrappersVisitor.cpp
  CollectVisitor.cpp
  Config.cpp
  DiagnosticsReporter.cpp
  Edge.cpp
  RecordInfo.cpp)

if(WIN32)
  # Clang doesn't support loadable modules on Windows. Unfortunately, building
  # the plugin as a static library and linking clang against it doesn't work.
  # Since clang doesn't reference any symbols in our static library, the linker
  # strips it out completely.
  # Instead, we rely on the fact that the SOURCES property of a target is no
  # read-only after CMake 3.1 and use it to compile the plugin directly into
  # clang...
  cmake_minimum_required(VERSION 3.1)
  # Paths must be absolute, since we're modifying a target in another directory.
  set(absolute_sources "")
  foreach(source ${plugin_sources})
    list(APPEND absolute_sources ${CMAKE_CURRENT_SOURCE_DIR}/${source})
  endforeach()
  set_property(TARGET clang APPEND PROPERTY SOURCES ${absolute_sources})

  cr_add_test(blink_gc_plugin_test
    python tests/test.py
    ${CMAKE_BINARY_DIR}/bin/clang
    )
else()
  add_llvm_loadable_module("lib${LIBRARYNAME}" ${plugin_sources})
  add_dependencies("lib${LIBRARYNAME}" clang)

  cr_install(TARGETS "lib${LIBRARYNAME}" LIBRARY DESTINATION lib)

  cr_add_test(blink_gc_plugin_test
    python tests/test.py
    ${CMAKE_BINARY_DIR}/bin/clang
    $<TARGET_FILE:lib${LIBRARYNAME}>
    )
endif()

=== debian/changelog ===
chromium-browser (68.0.3440.75-0ubuntu0.16.04.1) xenial; urgency=medium

  * Upstream release: 68.0.3440.75
    - CVE-2018-6153: Stack buffer overflow in Skia.
    - CVE-2018-6154: Heap buffer overflow in WebGL.
    - CVE-2018-6155: Use after free in WebRTC.
    - CVE-2018-6156: Heap buffer overflow in WebRTC.
    - CVE-2018-6157: Type confusion in WebRTC.
    - CVE-2018-6158: Use after free in Blink.
    - CVE-2018-6159: Same origin policy bypass in ServiceWorker.
    - CVE-2018-6160: URL spoof in Chrome on iOS.
    - CVE-2018-6161: Same origin policy bypass in WebAudio.
    - CVE-2018-6162: Heap buffer overflow in WebGL.
    - CVE-2018-6163: URL spoof in Omnibox.
    - CVE-2018-6164: Same origin policy bypass in ServiceWorker.
    - CVE-2018-6165: URL spoof in Omnibox.
    - CVE-2018-6166: URL spoof in Omnibox.
    - CVE-2018-6167: URL spoof in Omnibox.
    - CVE-2018-6168: CORS bypass in Blink.
    - CVE-2018-6169: Permissions bypass in extension installation.
    - CVE-2018-6170: Type confusion in PDFium.
    - CVE-2018-6171: Use after free in WebBluetooth.
    - CVE-2018-6172: URL spoof in Omnibox.
    - CVE-2018-6173: URL spoof in Omnibox.
    - CVE-2018-6174: Integer overflow in SwiftShader.
    - CVE-2018-6175: URL spoof in Omnibox.
    - CVE-2018-6176: Local user privilege escalation in Extensions.
    - CVE-2018-6177: Cross origin information leak in Blink.
    - CVE-2018-6178: UI spoof in Extensions.
    - CVE-2018-6179: Local file information leak in Extensions.
    - CVE-2018-6044: Request privilege escalation in Extensions.
    - CVE-2018-4117: Cross origin information leak in Blink.
  * debian/rules:
    - remove enable_webrtc build flag
    - make ninja less verbose to reduce build log size
  * debian/chromium-browser.sh.in: parse flashplugin manifest with Python 3
    (LP: #1772448)
  * debian/patches/add-missing-base-namespace.patch: added
  * debian/patches/chromium_useragent.patch: refreshed
  * debian/patches/configuration-directory.patch: refreshed
  * debian/patches/disable-sse2: refreshed
  * debian/patches/enable-chromecast-by-default.patch: refreshed
  * debian/patches/fix-crashpad-linux-compat.patch: removed, no longer needed
  * debian/patches/fix-extra-arflags.patch: updated
  * debian/patches/fix-ffmpeg-ia32-build.patch: updated
  * debian/patches/last-commit-position: refreshed
  * debian/patches/no-new-ninja-flag.patch: refreshed
  * debian/patches/revert-Xclang-instcombine-lower-dbg-declare.patch: updated
  * debian/patches/search-credit.patch: refreshed
  * debian/patches/set-rpath-on-chromium-executables.patch: refreshed
  * debian/patches/suppress-newer-clang-warning-flags.patch: updated
  * debian/patches/title-bar-default-system.patch-v35: refreshed
  * debian/patches/touch-v35: refreshed
  * debian/patches/use-clang-versioned.patch: refreshed
  * debian/known_gn_gen_args-*: remove enable_webrtc build flag

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 25 Jul 2018 10:51:24 +0200

chromium-browser (67.0.3396.99-0ubuntu0.16.04.2) xenial; urgency=medium

  * debian/patches/libcxxabi-arm-ehabi-fix.patch: removed, no longer needed

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 11 Jul 2018 10:22:52 +0200

chromium-browser (67.0.3396.99-0ubuntu0.16.04.1) xenial; urgency=medium

  * Upstream release: 67.0.3396.99
    - CVE-2018-6148: Incorrect handling of CSP header.
    - CVE-2018-6149: Out of bounds write in V8.
  * debian/control: build-depend on clang-6.0 and llvm-6.0, which are now in
    xenial-updates
  * debian/rules: build gn with clang 6.0
  * debian/patches/revert-clang-nostdlib++.patch: removed, no longer needed
  * debian/patches/suppress-newer-clang-warning-flags.patch: updated
  * debian/patches/use-clang-versioned.patch: updated

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Mon, 09 Jul 2018 23:51:26 +0200

chromium-browser (67.0.3396.62-0ubuntu0.16.04.1) xenial; urgency=medium

  * Upstream release: 67.0.3396.62
    - CVE-2018-6123: Use after free in Blink.
    - CVE-2018-6124: Type confusion in Blink.
    - CVE-2018-6125: Overly permissive policy in WebUSB.
    - CVE-2018-6126: Heap buffer overflow in Skia.
    - CVE-2018-6127: Use after free in indexedDB.
    - CVE-2018-6128: uXSS in Chrome on iOS.
    - CVE-2018-6129: Out of bounds memory access in WebRTC.
    - CVE-2018-6130: Out of bounds memory access in WebRTC.
    - CVE-2018-6131: Incorrect mutability protection in WebAssembly.
    - CVE-2018-6132: Use of uninitialized memory in WebRTC.
    - CVE-2018-6133: URL spoof in Omnibox.
    - CVE-2018-6134: Referrer Policy bypass in Blink.
    - CVE-2018-6135: UI spoofing in Blink.
    - CVE-2018-6136: Out of bounds memory access in V8.
    - CVE-2018-6137: Leak of visited status of page in Blink.
    - CVE-2018-6138: Overly permissive policy in Extensions.
    - CVE-2018-6139: Restrictions bypass in the debugger extension API.
    - CVE-2018-6140: Restrictions bypass in the debugger extension API.
    - CVE-2018-6141: Heap buffer overflow in Skia.
    - CVE-2018-6142: Out of bounds memory access in V8.
    - CVE-2018-6143: Out of bounds memory access in V8.
    - CVE-2018-6144: Out of bounds memory access in PDFium.
    - CVE-2018-6145: Incorrect escaping of MathML in Blink.
    - CVE-2018-6147: Password fields not taking advantage of OS protections in
      Views.
  * debian/rules: stop installing an outdated chromium-browser.svg icon
    (LP: #1771847)
  * debian/chromium-browser.svg: removed (outdated)
  * debian/patches/additional-search-engines.patch: refreshed
  * debian/patches/configuration-directory.patch: refreshed
  * debian/patches/default-allocator: refreshed
  * debian/patches/disable-sse2: updated
  * debian/patches/fix-crashpad-linux-compat.patch: added
  * debian/patches/fix-extra-arflags.patch: added
  * debian/patches/libcxxabi-arm-ehabi-fix.patch: refreshed
  * debian/patches/no-new-ninja-flag.patch: updated
  * debian/patches/revert-clang-nostdlib++.patch: refreshed


=== debian/control ===
Source: chromium-browser
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XS-Testsuite: autopkgtest
Vcs-Bzr: https://code.launchpad.net/~chromium-team/chromium-browser/xenial-stable
Homepage: https://chromium.googlesource.com/chromium/src/
Build-Depends:
	debhelper (>= 9),
	dh-buildinfo,
	ninja-build (>= 1.3),
	pkg-config,
	lsb-release,
	quilt,
	python,
	bison,
	clang-6.0,
	llvm-6.0,
	gperf,
	libpulse-dev,
	libcups2-dev | libcupsys2-dev,
	libasound2-dev,
	libnss3-dev,
	mesa-common-dev,
	libgles2-mesa-dev [armel armhf],
	libpci-dev,
	libxtst-dev,
	libxss-dev,
	libgtk-3-dev,
	libglib2.0-dev,
	libgnome-keyring-dev,
	libudev-dev,
	libdrm-dev,
	libcap-dev,
	libgcrypt-dev,
	libkrb5-dev,
	libxkbcommon-dev,
	libpam0g-dev,
	libffi-dev,
	chrpath,
	yasm
Standards-Version: 4.1.1

Package: chromium-browser
Architecture: i386 amd64 armhf arm64
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends},
	bash (>= 4),
	libnss3,
	xdg-utils,
	chromium-codecs-ffmpeg-extra (= ${binary:Version}) | chromium-codecs-ffmpeg (= ${binary:Version})
Recommends: chromium-browser-l10n
Suggests: webaccounts-chromium-extension,
	unity-chromium-extension,
	adobe-flashplugin
Provides: www-browser, chromium-browser-inspector, exec<usr/bin/chromium-browser>, mime<text/html>, mime<x-scheme-handler/http>, mime<x-scheme-handler/https>
Replaces: chromium-browser-inspector
Conflicts: chromium-browser-inspector
Description: Chromium web browser, open-source version of Chrome
 An open-source browser project that aims to build a safer, faster, and more
 stable way for all Internet users to experience the web.

Package: chromium-browser-l10n
Architecture: all
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${misc:Depends}, chromium-browser (>= ${binary:Version}),
 chromium-browser (<< ${binary:Version}.1~)
Replaces: chromium-browser
Description: chromium-browser language packages
 An open-source browser project that aims to build a safer, faster, and more
 stable way for all Internet users to experience the web.
 .
 This package contains language packages for 65 languages:
 am, ar, ast, bg, bn, bs, ca, ca@valencia, cs, da, de, el, en-AU, en-GB, eo,
 es-419, es, et, eu, fa, fil, fi, fr, gl, gu, he, hi, hr, hu, hy, ia, id, it,
 ja, ka, kn, ko, ku, kw, lt, lv, ml, mr, ms, nb, nl, pl, pt-BR, pt-PT, ro, ru,
 sk, sl, sr, sv, sw, ta, te, th, tr, ug, uk, vi, zh-CN, zh-TW

Package: chromium-codecs-ffmpeg
Architecture: i386 amd64 armhf arm64
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: chromium-codecs-ffmpeg-extra, chromium-browser (<< 44)
Replaces: chromium-codecs-ffmpeg-extra, chromium-browser (<< 44)
Description: Free ffmpeg codecs for the Chromium Browser
 An open-source browser project that aims to build a safer, faster, and more
 stable way for all Internet users to experience the web.
 .
 This package contains the multi-threaded ffmpeg codecs needed for the HTML5
 <audio> and <video> tags. Only the free ogg, vorbis and theora codecs are
 included. See chromium-codecs-ffmpeg-extra for additional codecs

Package: chromium-codecs-ffmpeg-extra
Architecture: i386 amd64 armhf arm64
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: chromium-codecs-ffmpeg, chromium-browser (<< 44)
Replaces: chromium-codecs-ffmpeg, chromium-browser (<< 44)
Description: Extra ffmpeg codecs for the Chromium Browser
 An open-source browser project that aims to build a safer, faster, and more
 stable way for all Internet users to experience the web.
 .
 This package contains the multi-threaded ffmpeg codecs needed for the HTML5
 <audio> and <video> tags. In addition to the patent-free ogg, vorbis and
 theora codecs, aac/ac3/mpeg4audio/h264/mov/mp3 are also included.  See
 chromium-codecs-ffmpeg if you prefer only the patent-free codecs

Package: chromium-chromedriver
Architecture: i386 amd64 armhf arm64
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends}, chromium-browser (>= 4.0.203.0~)
Description: WebDriver driver for the Chromium Browser
 Chromedriver serves as a bridge between Chromium Browser and Selenium 
 WebDriver.
 .
 See https://sites.google.com/a/chromium.org/chromedriver/ for details.

=== debian/rules ===
#!/usr/bin/make -f

DEBIAN_NAME := $(shell dpkg-parsechangelog | sed -n 's/^Source: *\(.*\)$$/\1/ p')
DEBIAN_VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)$$/\1/ p')
DEBIAN_UPSTREAM_VERSION := $(shell echo $(DEBIAN_VERSION) | sed 's/^\(.*\)-[^-]*$$/\1/')
DEBIAN_REVISION := $(shell echo $(DEBIAN_VERSION) | sed 's/^.*r\([^-]*\)-.*/\1/')
DEBIAN_DIST := $(shell lsb_release -ds | tr -d '()' |sed -e 's/\#/ /g')
DEBIAN_DIST_NAME	:= $(shell lsb_release -si |sed -e 's/\#/ /g')

LIB_DIR        := usr/lib/chromium-browser

ifneq (,$(findstring Ubuntu,$(DEBIAN_DIST)))
DISTRIBUTION := UBUNTU
UBUNTU_DIST := $(DEBIAN_DIST)
endif

# Set up Google API keys, see http://www.chromium.org/developers/how-tos/api-keys .
# Note: these are for Ubuntu use ONLY. For your own distribution,
# please get your own set of keys.
# Permission to add API keys, from Paweł Hajdan, To chad.miller@canonical.com
# msgid: CAADNaOFSFoch68NM1SGpCTRXqmspyKQgUPUtsF7SGRsRXiHZcg@mail.gmail.com
GOOGLEAPI_APIKEY_UBUNTU := AIzaSyDGQzx0c0ptZVDriLi9Wblo2voeLnmPq-o
GOOGLEAPI_CLIENTID_UBUNTU := 424119844901-tilod0e1nm0dt85e1evrdfp3cc3ec01d.apps.googleusercontent.com
GOOGLEAPI_CLIENTSECRET_UBUNTU := WCCejhqORuxKG272GAWxsPIU

common_defines :=
browser_defines :=
ffmpeg_std_defines :=
ffmpeg_extra_defines :=

# enable verbose build messages
export DH_VERBOSE=1

# enable all build hardening flags
#export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Don't let dh_installinit install *.default in /etc/default
DEB_DH_INSTALLINIT_ARGS += --noscripts --onlyscripts

# Don't let scour touch the svg files
DEB_DH_SCOUR_ARGS += -Xsvg

# FFmpeg-mt
# Builds separately twice, once with the Chrome branding to gain the extra
# codecs, and once without branding.  The ffmpeg_branding variable controls
# which codecs are built inside the ffmpeg lib.  By default, ffmpeg_branding
# equals to "Chromium" and only builds the ogg/vorbis/theora codecs.
# When set to "Chrome", it also builds aac/ac3/mpeg4audio/h264/mov/mp3
DEB_DH_SHLIBDEPS_ARGS_chromium-codecs-ffmpeg := -ldebian/chromium-codecs-ffmpeg/$(LIB_DIR)
DEB_DH_SHLIBDEPS_ARGS_chromium-codecs-ffmpeg-extra := -ldebian/chromium-codecs-ffmpeg-extra/$(LIB_DIR)

common_defines+=\
	enable_google_now=false \
	enable_hangout_services_extension=true \
	enable_mdns=true \
	enable_nacl=false \
	enable_wayland_server=false \
	enable_widevine=true \
	fieldtrial_testing_like_official_build=true \
	is_component_build=false \
	is_component_ffmpeg=true \
	is_debug=false \
	is_desktop_linux=true \
	is_official_build=true \
	remove_webcore_debug_symbols=true \
	symbol_level=1 \
	treat_warnings_as_errors=false \
	use_allocator="none" \
	use_alsa=true \
	use_aura=true \
	use_cups=true \
	use_dbus=true \
	use_gio=true \
	use_glib=true \
	use_gold=false \
	use_gtk3=true \
	use_libpci=true \
	use_pulseaudio=true \
	use_sysroot=false \
	use_system_harfbuzz=false \
	use_system_libjpeg=false \
	rtc_enable_protobuf=false \
	rtc_use_h264=true \
	is_clang=true \
	clang_base_path="/usr" \
	clang_use_chrome_plugins=false \
	use_lld=false \
	is_cfi=false \
	use_thin_lto=false \
	fatal_linker_warnings=false \
	target_os="linux" \
	current_os="linux" \
	optimize_webui=false

ffmpeg_std_defines   += proprietary_codecs=false
ffmpeg_extra_defines += proprietary_codecs=true ffmpeg_branding="Chrome"

# system libraries to use
use_system_libraries := #yasm libwebp libevent


#!#GN_DEF += enable_hidpi=true
$(warning gn hidpi)
#!#GYP_DEFINES += enable_touch_ui=1
$(warning gn touch ui)


## Debian got this name wrong. DEB_HOST is not the hosting machine of
## compilation, but the destination of the resulting compiled programs.
## DEB_HOST = target. DEB_BUILD = hosting machine. Someone forgot what 
## "to host" means, and thought of "host" as "computery thing".

ifeq (armel,$(DEB_HOST_ARCH))
common_defines += target_cpu="arm"
common_defines += arm_use_neon=false
common_defines += v8_use_arm_eabi_hardfloat=false
common_defines += arm_float_abi="soft" arm_use_thumb=false
else ifeq (armhf,$(DEB_HOST_ARCH))
common_defines += target_cpu="arm"
common_defines += arm_use_neon=false
common_defines += arm_float_abi="hard" arm_use_thumb=true
else ifeq (arm64,$(DEB_HOST_ARCH))
common_defines += target_cpu="arm64"
else ifeq (i386,$(DEB_HOST_ARCH))
common_defines += target_cpu="x86"
else ifeq (amd64,$(DEB_HOST_ARCH))
common_defines += target_cpu="x64"
else ifeq (mipsel,$(DEB_HOST_ARCH))
common_defines += target_cpu="mipsel"
else ifeq ($(DEB_HOST_ARCH),)
else
$(warning unanticipated arch $(DEB_HOST_ARCH))
common_defines += target_arch="$(DEB_HOST_ARCH)"
endif

ifeq (armel,$(DEB_BUILD_ARCH))
else ifeq (armhf,$(DEB_BUILD_ARCH))
else ifeq (arm64,$(DEB_BUILD_ARCH))
else ifeq (i386,$(DEB_BUILD_ARCH))
else ifeq (amd64,$(DEB_BUILD_ARCH))
else ifeq (mipsel,$(DEB_BUILD_ARCH))
else
$(warning unanticipated arch $(DEB_HOST_ARCH))
endif


ifneq (,$(GOOGLEAPI_APIKEY_$(DISTRIBUTION)))
common_defines += \
	google_api_key="$(GOOGLEAPI_APIKEY_$(DISTRIBUTION))" \
	google_default_client_id="$(GOOGLEAPI_CLIENTID_$(DISTRIBUTION))" \
	google_default_client_secret="$(GOOGLEAPI_CLIENTSECRET_$(DISTRIBUTION))"
else
$(warning Google API info is not set in build variables GOOGLEAPI_APIKEY_$(DISTRIBUTION) GOOGLEAPI_CLIENTID_$(DISTRIBUTION) GOOGLEAPI_CLIENTSECRET_$(DISTRIBUTION))
endif

### Official interfaces.

# Debian Policy §4.9
binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep patch:
	dh $@ --builddirectory=out --with quilt

# BZR build-deb rule
get-packaged-orig-source: URL=https://commondatastorage.googleapis.com/chromium-browser-official/chromium-$(ORIG_VERSION).tar.xz
get-packaged-orig-source: SUMURL=https://commondatastorage.googleapis.com/chromium-browser-official/chromium-$(ORIG_VERSION).tar.xz.hashes
get-packaged-orig-source: DEST_FILENAME=chromium-browser_$(ORIG_VERSION).orig.tar.xz
get-packaged-orig-source:
	wget --continue --progress=dot:giga $(URL)
	wget -O sumfile -q $(SUMURL); echo >>sumfile
	for hasher in md5 sha1 sha224 sha256 sha384 sha512; do echo -n "$$hasher  "; $${hasher}sum chromium-$(ORIG_VERSION).tar.xz; done >testfile
	diff testfile sumfile
	mv "chromium-$(ORIG_VERSION).tar.xz" "$(DEST_FILENAME)"

# Debian Policy §4.9
get-orig-source:
	test "$(ORIG_VERSION)" || { echo "Set ORIG_VERSION" to use this rule.; exit 1; }
	ORIG_VERSION=$(ORIG_VERSION) $(MAKE) get-packaged-orig-source


### Below here, rules that support those above required ones.

override_dh_auto_configure: ARG_TEST_FILE := debian/known_gn_gen_args-$(DEB_HOST_ARCH)
override_dh_auto_configure: out/Release/gn
	# Upstream changes often. Fail when they introduce a config flag we don't know about.
	out/Release/gn gen out/argtest --fail-on-unused-args --args='$(common_defines) $(browser_defines) $(ffmpeg_extra_defines)'
	out/Release/gn args out/argtest --list --short |sed -e 's,$(HOME),$$HOME,' >out/argtest/discovered-gn-values
	@diff --suppress-common-lines --unified=0 $(ARG_TEST_FILE) out/argtest/discovered-gn-values || { echo; echo; echo Do:  cat \>$(ARG_TEST_FILE) \<\<EOF; cat out/argtest/discovered-gn-values; echo EOF; echo; echo; }

	-grep is_component out/argtest/discovered-gn-values

	test ! "$(use_system_libraries)" || python2 build/linux/unbundle/replace_gn_files.py --system-libraries $(use_system_libraries)
	out/Release/gn gen --fail-on-unused-args --args='$(common_defines) $(browser_defines) $(ffmpeg_extra_defines)' out/Release

	out/Release/gn gen --fail-on-unused-args --args='$(common_defines) $(ffmpeg_std_defines)' out/ffmpeg-std


# There are two things to build. Standard ffmpeg+browser, and full ffmpeg.
override_dh_auto_build: BUILD_TARGETS := chrome chrome_sandbox chromedriver
override_dh_auto_build:
	ninja -C out/Release $(BUILD_TARGETS)
	ninja -C out/ffmpeg-std libffmpeg.so

override_dh_fixperms:
	dh_fixperms --exclude chrome-sandbox

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_installman:
	# install does this

## chromium-browser 69.0.3497.81

=== tools/clang/plugins/CMakeLists.txt ===
set(plugin_sources
  ChromeClassTester.cpp
  FindBadConstructsAction.cpp
  FindBadConstructsConsumer.cpp
  CheckIPCVisitor.cpp
  Util.cpp
)

if(WIN32)
  # Clang doesn't support loadable modules on Windows. Unfortunately, building
  # the plugin as a static library and linking clang against it doesn't work.
  # Since clang doesn't reference any symbols in our static library, the linker
  # strips it out completely.
  # Instead, we rely on the fact that the SOURCES property of a target is no
  # read-only after CMake 3.1 and use it to compile the plugin directly into
  # clang...
  cmake_minimum_required(VERSION 3.1)
  # Paths must be absolute, since we're modifying a target in another directory.
  set(absolute_sources "")
  foreach(source ${plugin_sources})
    list(APPEND absolute_sources ${CMAKE_CURRENT_SOURCE_DIR}/${source})
  endforeach()
  set_property(TARGET clang APPEND PROPERTY SOURCES ${absolute_sources})

  cr_add_test(plugins_test
    python tests/test.py
    ${CMAKE_BINARY_DIR}/bin/clang
  )
else()
  add_llvm_loadable_module(libFindBadConstructs ${plugin_sources})
  add_dependencies(libFindBadConstructs clang)

  cr_install(TARGETS libFindBadConstructs LIBRARY DESTINATION lib)

  cr_add_test(plugins_test
    python tests/test.py
    ${CMAKE_BINARY_DIR}/bin/clang
    $<TARGET_FILE:libFindBadConstructs>
  )
endif()

=== debian/changelog ===
chromium-browser (69.0.3497.81-3) unstable; urgency=medium

  * Move another file needed for the armhf build to where it is expected.

 -- Michael Gilbert <mgilbert@debian.org>  Fri, 07 Sep 2018 00:06:13 +0000

chromium-browser (69.0.3497.81-2) unstable; urgency=medium

  * Disable swiftshader.
  * Move file needed for the armhf build to where it is expected.
  * Document disabled built-in extensions in README.debian (closes: #886358).

 -- Michael Gilbert <mgilbert@debian.org>  Thu, 06 Sep 2018 01:45:12 +0000

chromium-browser (69.0.3497.81-1) unstable; urgency=medium

  * New upstream stable release.
    - CVE-2018-16065: Out of bounds write in V8. Reported by Brendon Tiszka
    - CVE-2018-16066: Out of bounds read in Blink. Reported by cloudfuzzer
    - CVE-2018-16067: Out of bounds read in WebAudio. Reported by Zhe Jin
    - CVE-2018-16068: Out of bounds write in Mojo. Reported by Mark Brand
    - CVE-2018-16069: Out of bounds read in SwiftShader. Reported by Mark Brand
    - CVE-2018-16070: Integer overflow in Skia. Reported by Ivan Fratric
    - CVE-2018-16071: Use after free in WebRTC. Reported by Natalie Silvanovich
    - CVE-2018-16073: Site Isolation bypass after tab restore. Reported by Jun
      Kokatsu
    - CVE-2018-16074: Site Isolation bypass using Blob URLS. Reported by Jun
      Kokatsu
    - CVE-2018-16075: Local file access in Blink. Reported by Pepe Vila
    - CVE-2018-16076: Out of bounds read in PDFium. Reported by Aleksandar
      Nikolic
    - CVE-2018-16077: Content security policy bypass in Blink. Reported by
      Manuel Caballero
    - CVE-2018-16078: Credit card information leak in Autofill. Reported by
      Cailan Sacks
    - CVE-2018-16079: URL spoof in permission dialogs. Reported by Markus
      Vervier and Michele Orrù
    - CVE-2018-16080: URL spoof in full screen mode. Reported by Khalil Zhani
    - CVE-2018-16081: Local file access in DevTools. Reported by Jann Horn
    - CVE-2018-16082: Stack buffer overflow in SwiftShader. Reported by Omair
    - CVE-2018-16083: Out of bounds read in WebRTC. Reported by Natalie
      Silvanovich
    - CVE-2018-16084: User confirmation bypass in external protocol handling.
      Reported by Jun Kokatsu
    - CVE-2018-16085: Use after free in Memory Instrumentation. Reported by
      Roman Kuksin

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 05 Sep 2018 00:01:50 +0000

chromium-browser (69.0.3497.12-1) experimental; urgency=medium

  * New upstream development release.
    - Fixes an error that can occur on pages containing xml (closes: #865592).
  * Install swiftshader libraries to /usr/lib/chromium (closes: #901831).

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 29 Jul 2018 09:30:34 +0000

chromium-browser (68.0.3440.75-2) unstable; urgency=medium

  * Restore a mistakenly omitted call to InitializeFFmpeg (closes: #902909).

 -- Michael Gilbert <mgilbert@debian.org>  Thu, 26 Jul 2018 00:37:11 +0000

chromium-browser (68.0.3440.75-1) unstable; urgency=medium

  * New upstream stable release.
    - CVE-2018-4117: Cross origin information leak in Blink. Reported by
      AhsanEjaz
    - CVE-2018-6044: Request privilege escalation in Extensions . Reported by
      Rob Wu
    - CVE-2018-6150: Cross origin information disclosure in Service Workers.
      Reported by Rob Wu
    - CVE-2018-6151: Bad cast in DevTools. Reported by Rob Wu
    - CVE-2018-6152: Local file write in DevTools. Reported by Rob Wu
    - CVE-2018-6153: Stack buffer overflow in Skia. Reported by Zhen Zhou
    - CVE-2018-6154: Heap buffer overflow in WebGL. Reported by Omair
    - CVE-2018-6155: Use after free in WebRTC. Reported by Natalie Silvanovich
    - CVE-2018-6156: Heap buffer overflow in WebRTC. Reported by Natalie
      Silvanovich
    - CVE-2018-6157: Type confusion in WebRTC. Reported by Natalie Silvanovich
    - CVE-2018-6158: Use after free in Blink. Reported by Zhe Jin
    - CVE-2018-6159: Same origin policy bypass in ServiceWorker. Reported by
      Jun Kokatsu
    - CVE-2018-6161: Same origin policy bypass in WebAudio. Reported by Jun
      Kokatsu
    - CVE-2018-6162: Heap buffer overflow in WebGL. Reported by Omair
    - CVE-2018-6163: URL spoof in Omnibox. Reported by Khalil Zhani
    - CVE-2018-6164: Same origin policy bypass in ServiceWorker. Reported by
      Jun Kokatsu
    - CVE-2018-6165: URL spoof in Omnibox. Reported by evi1m0
    - CVE-2018-6166: URL spoof in Omnibox. Reported by Lnyas Zhang
    - CVE-2018-6167: URL spoof in Omnibox. Reported by Lnyas Zhang
    - CVE-2018-6168: CORS bypass in Blink. Reported by Gunes Acar and Danny Y.
      Huang
    - CVE-2018-6169: Permissions bypass in extension installation . Reported by
      Sam P
    - CVE-2018-6170: Type confusion in PDFium. Reported by Anonymous
    - CVE-2018-6171: Use after free in WebBluetooth.
    - CVE-2018-6172: URL spoof in Omnibox. Reported by Khalil Zhani
    - CVE-2018-6173: URL spoof in Omnibox. Reported by Khalil Zhani
    - CVE-2018-6174: Integer overflow in SwiftShader. Reported by Mark Brand
    - CVE-2018-6175: URL spoof in Omnibox. Reported by Khalil Zhani
    - CVE-2018-6176: Local user privilege escalation in Extensions. Reported by
      Jann Horn
    - CVE-2018-6177: Cross origin information leak in Blink. Reported by Ron
      Masas
    - CVE-2018-6178: UI spoof in Extensions. Reported by Khalil Zhani
    - CVE-2018-6179: Local file information leak in Extensions.

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 25 Jul 2018 00:28:20 +0000

chromium-browser (68.0.3440.42-1) experimental; urgency=medium

  * New upstream beta release.

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 30 Jun 2018 17:46:03 +0000

chromium-browser (68.0.3440.33-1) experimental; urgency=medium

  * New upstream beta release.
  * Build using upstream's "lite" tarball.
  * Restore decoder initialization from chromium 66 to maintain compatibility
    with ffmpeg 3.4 (closes: #900533).

 -- Michael Gilbert <mgilbert@debian.org>  Fri, 29 Jun 2018 20:48:51 +0000



=== debian/control ===
Source: chromium-browser
Section: web
Priority: optional
Maintainer: Debian Chromium Team <chromium-browser@packages.debian.org>
Uploaders:
 Michael Gilbert <mgilbert@debian.org>, Riku Voipio <riku.voipio@linaro.org>
Vcs-Git: https://salsa.debian.org/chromium-team/chromium.git
Vcs-Browser: https://salsa.debian.org/chromium-team/chromium
Homepage: http://www.chromium.org/Home
Rules-Requires-Root: no
Build-Depends:
 debhelper (>= 11),
 g++-6 (>= 6.4.0-18),
 python3,
 pkg-config,
 ninja-build,
 python-jinja2,
 ca-certificates,
 wget,
 flex,
 yasm,
 xvfb,
 wdiff,
 gperf,
 bison,
 valgrind,
 xz-utils,
 x11-apps,
 xfonts-base,
 libglewmx-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libegl1-mesa-dev,
 libgles2-mesa-dev,
 mesa-common-dev,
 libxt-dev,
 libre2-dev,
 libgbm-dev,
 libpng-dev,
 libxss-dev,
 libelf-dev,
 libvpx-dev (>= 1.7.0),
 libpci-dev,
 libcap-dev,
 libdrm-dev,
 libicu-dev,
 libffi-dev,
 libkrb5-dev,
 libexif-dev,
 libflac-dev,
 libudev-dev,
 libopus-dev,
 libwebp-dev,
 libxtst-dev,
 libsrtp-dev,
 libjpeg-dev,
 libxml2-dev,
 libgtk-3-dev,
 libxslt1-dev,
 liblcms2-dev,
 libpulse-dev,
 libpam0g-dev,
 libsnappy-dev,
 libavutil-dev,
 libavcodec-dev (>= 7:3.0),
 libavformat-dev,
 libglib2.0-dev,
 libasound2-dev,
 libjsoncpp-dev,
 libspeechd-dev (>= 0.8.4),
 libminizip-dev,
 libhunspell-dev,
 libharfbuzz-dev (>= 1.2.7),
 libusb-1.0-0-dev,
 libopenjp2-7-dev,
 libmodpbase64-dev,
 libnss3-dev (>= 3.12.3),
 libnspr4-dev (>= 2:4.9),
 libcups2-dev (>= 1.5.0),
 libevent-dev (>= 1.4.13),
 libjs-jquery,
 libjs-excanvas,
 libjs-jquery-flot,
 libgcrypt20-dev,
 fonts-ipafont-gothic,
 fonts-ipafont-mincho,
Standards-Version: 4.1.4

Package: chromium
Architecture: i386 amd64 arm64 armhf
Built-Using: ${Built-Using}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium-common (= ${binary:Version}),
Suggests:
 chromium-l10n,
 chromium-shell,
 chromium-driver,
Provides:
 www-browser,
 gnome-www-browser,
Conflicts:
 libnettle4,
 libsecret-1-0 (<< 0.18),
 libgl1-mesa-swx11,
Description: web browser
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains the web browser component.

Package: chromium-l10n
Architecture: all
Section: localization
Depends:
 ${misc:Depends},
 chromium (>= ${source:Version}), chromium (<< ${source:Version}.1~),
Description: web browser - language packs
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains language packages for:
 am, ar, bg, bn, ca, cs, da, de, el, en-GB, es-419, es, et, fi, fil, fr, gu, he,
 hi, hr, hu, id, it, ja, kn, ko, lt, lv, ml, mr, nb, nl, pl, pt-BR, pt-PT,
 ro, ru, sk, sl, sr, sv, sw, ta, te, th, tr, uk, vi, zh-CN, zh-TW

Package: chromium-shell
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium-common (= ${binary:Version}),
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - minimal shell
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a minimal version of the chromium user interface
 (the content shell).

Package: chromium-driver
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 chromium (= ${binary:Version}),
Description: web browser - WebDriver support
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package provides a bridge between the browser component and the selenium
 automatic webdriver.

Package: chromium-common
Architecture: i386 amd64 arm64 armhf
Depends:
 ${misc:Depends},
 x11-utils,
 xdg-utils,
Recommends:
 upower,
 libu2f-udev,
 libgl1-mesa-dri,
 fonts-liberation,
 notification-daemon,
Breaks:
 chromium (<< ${binary:Version}),
Replaces:
 chromium (<< ${binary:Version}),
Description: web browser - common resources used by the chromium packages
 Web browser that aims to build a safer, faster, and more stable internet
 browsing experience.
 .
 This package contains resources that are in common to different chromium
 packages.

=== debian/rules ===
#!/usr/bin/make -f

# enable verbose build messages
export DH_VERBOSE=1

# enable all build hardening flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# indicate that binary targets do not require root
export DEB_RULES_REQUIRES_ROOT=no

# build using a stretch-like environment (to reduce backporting effort)
export AR=ar
export NM=nm
export CC=gcc-6
export CXX=g++-6

# more verbose linker output
export LDFLAGS+=-Wl,--stats

# extra flags to reduce warnings that aren't very useful
export CXXFLAGS+=-Wno-pedantic \
                 -Wno-unused-function \
                 -Wno-unused-variable \
                 -Wno-unused-but-set-variable \
                 -Wno-deprecated-declarations \

# ignore warnings for minor mistakes that are too common
export CXXFLAGS+=-Wno-return-type \
                 -Wno-misleading-indentation \

# ignore warnings that are not supported well until gcc 8
export CXXFLAGS+=-Wno-attributes \
                 -Wno-subobject-linkage \

# ignore warnings due to gcc bug (https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84055)
export CXXFLAGS+=-Wno-ignored-attributes

# disable clang options
defines=is_clang=false clang_use_chrome_plugins=false

# build using system toolchain
defines+=host_toolchain=\"//build/toolchain/linux/unbundle:default\"
defines+=custom_toolchain=\"//build/toolchain/linux/unbundle:default\"

# set the appropriate cpu architecture
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
ifeq (i386,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x86\"
endif
ifeq (amd64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"x64\"
endif
ifeq (arm64,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm64\"
endif
ifeq (armhf,$(DEB_HOST_ARCH))
defines+=host_cpu=\"arm\" arm_use_neon=false symbol_level=0
endif

# disabled features
defines+=is_debug=false \
         use_allocator=\"none\" \
         use_ozone=false \
         use_sysroot=false \
         use_openh264=false \
         use_kerberos=false \
         use_libjpeg_turbo=true \
         use_custom_libcxx=false \
         use_gnome_keyring=false \
         use_unofficial_version_number=false \
         treat_warnings_as_errors=false \
         remove_webcore_debug_symbols=true \
         optimize_webui=false \
         enable_swiftshader=false \
         enable_nacl=false \
         enable_nacl_nonsfi=false \
         enable_google_now=false \
         enable_reading_list=false \
         enable_hangout_services_extension=false \
         enable_iterator_debugging=false \
         goma_dir=\"\" \
         gold_path=\"\" \
         linux_use_bundled_binutils=false \

# enabled features
defines+=use_gio=true \
         use_gold=true \
         use_gtk3=true \
         use_pulseaudio=true \
         link_pulseaudio=true \
         enable_widevine=true \
         use_system_zlib=true \
         use_system_lcms2=true \
         use_system_libjpeg=true \
         use_system_freetype=true \
         use_system_harfbuzz=true \
         use_jumbo_build=true \
         jumbo_file_merge_limit=12 \
         concurrent_links=1 \
         optimize_for_size=true \
         proprietary_codecs=true \
         ffmpeg_branding=\"Chrome\" \
         fieldtrial_testing_like_official_build=true \

# some notes about embedded libraries
#  can't use system nss since net/third_party/nss is heavily patched
#  can't use system ots (open text *summarizer*) since that's not google's ots (open text *sanitizer*)

# handle parallel build options
njobs=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# paths to files needed by flot
flotpaths=/usr/share/javascript/jquery/*min.js \
          /usr/share/javascript/jquery-flot/*min.js \

%:
	dh $@

out/Release/gn:
	cp base/numerics/safe_conversions_arm_impl.h base/numerics/safe_math_arm_impl.h tools/gn/base/numerics
	./tools/gn/bootstrap/bootstrap.py -j$(njobs)

override_dh_auto_configure:
	# output compiler information
	$(CXX) --version
	# use system flot
	for file in $(flotpaths); do ln -sf $$file third_party/flot; done
	# put yasm script in the location expected by gn
	ln -sf ../pdfium/third_party/yasm/run_yasm.py third_party/yasm
	# strip out system third_party libraries
	rm -f base/third_party/libevent/BUILD.gn build/config/freetype/freetype.gni
	./debian/scripts/unbundle

override_dh_auto_build-arch: out/Release/gn
	./out/Release/gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release chrome chrome_sandbox content_shell chromedriver
	cp out/Release/chrome out/Release/chromium
	cp out/Release/content_shell out/Release/chromium-shell
	cp out/Release/chrome_sandbox out/Release/chrome-sandbox
	cp out/Release/locales/en-US.pak out/Release/resources
	chmod 4755 out/Release/chrome-sandbox # suid sandbox
	sed -e s/@@PACKAGE@@/chromium/g -e s/@@MENUNAME@@/chromium/g \
	    < chrome/app/resources/manpage.1.in > out/Release/chromium.1

override_dh_auto_build-indep: out/Release/gn
	./out/Release/gn gen out/Release --args="$(defines)"
	ninja -j$(njobs) -C out/Release packed_resources
	rm -f out/Release/locales/en-US.pak

override_dh_auto_install-arch:
	dh_auto_install
	# create /etc/chromium.d README file
	echo "Any files placed in this directory will be sourced prior to executing chromium." \
	    > debian/chromium/etc/chromium.d/README
	# update launcher script with build information
	sed 's|@BUILD_DIST@|$(shell cat /etc/debian_version)|' \
	    < debian/scripts/chromium > debian/chromium/usr/bin/chromium
	# move icons into /usr/share
	./debian/scripts/icons

override_dh_fixperms:
	dh_fixperms --exclude chrome-sandbox

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W libjs-jquery libjs-jquery-flot)"

override_dh_auto_clean:
	rm -rf out
	find . -name \*.pyc -execdir rm -f {} \;
	dh_auto_clean

###################### upstream source downloading ############################

url=https://gsdview.appspot.com/chromium-browser-official
version=$(shell dpkg-parsechangelog -S Version | sed s/-.*//)
extract=chromium-$(version)
tarfile=$(extract)-lite.tar
tarball=$(tarfile).xz
debvers=../chromium-browser_$(version)
origtxz=$(debvers).orig.tar.xz
removed=$(debvers).files-removed
seconds=$(debvers).seconds

get-orig-source:
	wget -nv --show-progress -c $(url)/$(tarball) -O ../$(tarball)
	cp /usr/bin/mk-origtargz debian/scripts
	patch -p1 < debian/scripts/mk-origtargz.patch
	date +%s > $(seconds)
	./debian/scripts/mk-origtargz ../$(tarball) > $(removed)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	test ! -e $(extract) || rm -rf $(extract)
	tar xf ../$(tarball)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	while read line; do rm -rf $$line; done < $(removed)
	cd $(extract) && ../debian/scripts/check-upstream
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	test ! -e $(origtxz) || rm -f $(origtxz)
	tar cf - $(extract) | xz -6 -T $(njobs) - > $(origtxz)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds
	rm -rf $(extract)
	echo $$(($$(date +%s) - $$(cat $(seconds)))) seconds | tee seconds
	@mv -f seconds $(seconds)
